unit uMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls
  ,xexecd, xspawn
  ,uWatcher
  ;

type
  TMain = class(TForm)
    GroupBox1: TGroupBox;
    ebDir: TEdit;
    ebFileName: TEdit;
    ebArgs: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnBrowse: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    cbDebugMode: TCheckBox;
    cbUseShell: TCheckBox;
    GroupBox5: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    pnlHostOS: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    pnlXSpawnVer: TPanel;
    Panel6: TPanel;
    btnStartWatcher: TButton;
    btnQuit: TButton;
    rbDos: TRadioButton;
    rbWin16: TRadioButton;
    rbAuto: TRadioButton;
    rbWin32: TRadioButton;
    rbOS2: TRadioButton;
    cdFileOpen: TOpenDialog;
    procedure btnBrowseClick(Sender: TObject);
    procedure btnQuitClick(Sender: TObject);
    procedure btnStartWatcherClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

{$R *.DFM}

procedure TMain.btnBrowseClick(Sender: TObject);
begin
	if (cdFileOpen.Execute) then
    	ebFileName.Text := cdFileOpen.FileName;
end;

procedure TMain.btnQuitClick(Sender: TObject);
begin
	close;
end;

procedure TMain.btnStartWatcherClick(Sender: TObject);
var
	hExec : longint;
	dwErrorCode : longint;
	wOptions : word;
  	watcher : TWatcher;
begin
	if (rbAuto.Checked) then
    	wOptions := WXO_AUTO
    else if (rbDos.Checked) then
    	wOptions := WXO_DOS
    else if (rbWin16.Checked) then
    	wOptions := WXO_WIN16
    else if (rbWin32.Checked) then
    	wOptions := WXO_WIN32
    else if (rbOS2.Checked) then
    	wOptions := WXO_OS2
    ;

    if (cbUseShell.Checked) then
    	wOptions := wOptions or WXO_USESHELL;

    WXSetDebugMode(cbDebugMode.Checked); 

    if (ebFileName.Text = '') then
    begin
    	MessageDlg('No file name was specified',
        			mtError, [mbOk], 0);
        exit;
    end; { if }

    watcher := TWatcher.Create(Application,
    							ebFileName.Text,
                                ebArgs.Text,
                                ebDir.Text,
                                SW_SHOWNORMAL,
                                wOptions
                                );
    watcher.Show;

end;

procedure TMain.FormCreate(Sender: TObject);
var
	wVersion : word;
begin
	Caption := Application.Title;

    { determine XSpawn's version and display it }
    wVersion := WXGetVersion;
    pnlXSpawnVer.Caption := Format('%d.%d',
    	[HIBYTE(wVersion), LOBYTE(wVersion)]);

    { determine the host os and display it }
    case WXGetHostOS of
        WX_UNKNOWN : pnlHostOs.Caption := 'Unknown';
        WX_OS_WIN3X : pnlHostOs.Caption := 'Windows 3.X';
        WX_OS_WINNT : pnlHostOs.Caption := 'Windows NT';
        WX_OS_WINOS2 : pnlHostOs.Caption := 'Win-OS/2';
    end; { case }
end;

end.
